<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class InsumoFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function dadosInsumo() {
      $sql = "SELECT FCM_INSUMO.NRINSUMO, FCM_INSUMO.NMINSUMO, FCM_INSUMO.CDINSUMO,FCM_UNIDADEMEDIDA.NMUNIDADEMEDIDA, FCM_UNIDADEMEDIDA.NMABREVUNIDADEMEDIDA,
                     CASE WHEN FCM_INSUMO.QTESTOQUE IS NULL THEN 0 ELSE FCM_INSUMO.QTESTOQUE END AS QTESTOQUE,
                     CASE WHEN FCM_INSUMO.QTULTIMARETIRADA IS NULL THEN 0 ELSE FCM_INSUMO.QTULTIMARETIRADA END AS QTULTIMARETIRADA
                FROM FCM_INSUMO
                JOIN FCM_UNIDADEMEDIDA
                  ON FCM_INSUMO.NRUNIDADEMEDIDA = FCM_UNIDADEMEDIDA.NRUNIDADEMEDIDA";

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function Insumo($dados) {
      $sql = "INSERT INTO FCM_INSUMO (NRINSUMO, NMINSUMO, CDINSUMO, CDPRODUTO, NRUNIDADEMEDIDA)
              VALUES (:NRINSUMO, :NMINSUMO, :CDINSUMO, :CDPRODUTO, :NRUNIDADEMEDIDA)";

      $std = $this->connection->prepare($sql);
      $std->execute($dados);
    }
}

?>