<?php

namespace FM\Service;

use FM\Factory\InsumoFactory;
use FM\Factory\ImgInsumoFactory;
use FM\Service\FileServerService;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class InsumoService {

    protected $InsumoFactory;
    protected $ImgInsumoFactory;
    protected $FileServerService;
    protected $Environment;
    protected $newCode;
    protected $connection;
    protected $fileServerApiKeys;

    public function __construct (EntityManager $entityManager, FileServerService $FileServerService, ImgInsumoFactory $ImgInsumoFactory, InsumoFactory $InsumoFactory, Environment $Environment, NewCode $newCode,  $fileServerApiKeys) {
        $this->InsumoFactory = $InsumoFactory;
        $this->ImgInsumoFactory = $ImgInsumoFactory;
        $this->FileServerService = $FileServerService;
        $this->Environment = $Environment;
        $this->connection = $entityManager->getConnection();
        $this->newCode = $newCode;
        $this->fileServerApiKeys = $fileServerApiKeys;
    }
    
    public function dadosInsumo(){
        return $this->InsumoFactory->dadosInsumo();
    }
    
    public function insumo($dadosFront){
        $this->connection->beginTransaction();
        
        try {
            $NRINSUMO = $this->newCode->getCodeByTableName("FCM_INSUMO", 20, 1, 10, true);
            $this->InsumoFactory->insumo(array(
                "NRINSUMO" => $NRINSUMO,
                "NMINSUMO" => $dadosFront['DADOS']['TextInputTipoInsumo'],
                "CDINSUMO" => ($dadosFront['DADOS']['TextInputCodInsumo'] != "") ? $dadosFront['DADOS']['TextInputCodInsumo'] : NULL,
                "CDPRODUTO" => $dadosFront['DADOS']['SelectProdutos'],
                "NRUNIDADEMEDIDA" => $dadosFront['DADOS']['SelectUnidadeMedida'],
            ));
            
            $row = $this->FileServerService->uploadImagensManut($dadosFront['IMAGENS']);
            foreach ($row as $file) {
                $this->ImgInsumoFactory->insertImg(array(
                    "NRIMGINSUMO" => $this->newCode->getCodeByTableName('FCM_IMGINSUMO', 20, 1, 10, true),
                    "NRINSUMO" => $NRINSUMO,
                    "DSCAMINHO" => $file['DS'],
                    "NRORG" => 20,
                    "DSTYPE" => $file['DSTYPE'],
                    "NRSIZE" => $file['QTSIZE']
                ));
            }
            
            $this->connection->commit();
            $response = "OK";
        } catch(\Exception $e) {
            $this->connection->rollback();
            $response = ($e->getMessage());
        }
        return $response;
    }
}

?>