/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_MEDICAMENTO                                              */
/* Tabela : MEDICAMENTO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MEDICAMENTO'  and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
  DROP TRIGGER DTULTATU_MEDICAMENTO
  GO


CREATE TRIGGER DTULTATU_MEDICAMENTO
ON MEDICAMENTO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'MEDICAMENTO', NULL, 'CDMEDICAMENT='+CDMEDICAMENT+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MEDICAMENTO
      SET DTULTATUMDTO = GETDATE()
      FROM INSERTED
      WHERE
         (MEDICAMENTO.CDMEDICAMENT = INSERTED.CDMEDICAMENT)
   END;
END;
GO



